/*
 * $Id: a4067b1a9de3a4c79055fc02292ba23fa8d4bebe $
 *
 * This file is part of ntldap.
 *
 * Copyright (c) 2006, 2007, 2008 Niklas Olmes <niklas@noxa.de>
 *                                http://www.nevm.de/ntldap/
 *                                NEVM-RIPE
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

#include <stdio.h>
#include <string.h>

#include "progname.h"

#if !(defined(__NetBSD__) || defined(__FreeBSD__) || defined(DARWIN))

static const char rcsid[] = "$Id: a4067b1a9de3a4c79055fc02292ba23fa8d4bebe $";

#if !defined(__OpenBSD__)
static char __progname[128];
#endif

void
setprogname(const char *name)
{
#if !defined(__OpenBSD__)
	(void)snprintf(__progname, sizeof(__progname), "%s", strrchr(name, '/') != NULL ? strrchr(name, '/') + 1 : "(unknown progname)");
#else
	; /* OpenBSD has __progname set for us */
#endif
}

const char *
getprogname(void)
{
	return __progname;
}

#endif
